/* get the directory tree */

#include <unistd.h>
#include <stdio.h>
#include <sys/types.h>
#include <dirent.h>
#include <sys/stat.h>

#include "dircache.h"

int dirlow_isdir(char *d)
{
	struct stat buf;
	int id;
	
	stat(d,&buf);
	
	id=S_ISDIR(buf.st_mode);

	return id;
}
;

unsigned int dirlow_filesize(char *d)
{
	struct stat buf;
	unsigned int fs;
	
	stat(d,&buf);
	
	fs=buf.st_size;
	
	return fs;
}
;

int dirlow_subdirentries(char *d)
{
	DIR *dir;
	struct dirent *entry;
	int entries;
	
	char subdirname[255];
	
	dir=opendir(d);
	entries=0;
	if (dir!=NULL)
	  {
		  while (((entry=readdir(dir))!=NULL)&&(entries==0))
		    {
			    strcpy((char*)&subdirname,d);
			    if (d[strlen(d)-1]!="/"[0])
				strcat((char*)&subdirname,"/");
			    strcat((char*)&subdirname,(char*)&entry->d_name);
			    if ( strcmp((char*)&entry->d_name,".")  &&
			         strcmp((char*)&entry->d_name,"..") &&
				 dirlow_isdir((char*)&subdirname)
				)
				entries++;
		    }
		  ;
		  closedir(dir);
	  }
	else entries=-1;
	return entries;
}
;
	

unsigned int dirlow_timestamp(char *d)
{
	struct stat buf;
	if (stat(d,&buf)==-1) buf.st_mtime=-1;
	return buf.st_mtime;
}
;

	    
int dirlow_removedir(char *d)
{	
	DIR *dir;
	struct dirent *entry;
	
	char fullent[1024];
	
	dir=opendir(d);
	if (dir!=NULL)
	  {
		  while ((entry=readdir(dir))!=NULL)
		    {
			    if (strcmp((char*)&entry->d_name,".")&&
				strcmp((char*)&entry->d_name,".."))
			      {				      
				      strcpy((char*)&fullent,d);
				      if (d[strlen(d)-1]!="/"[0])
					  strcat((char*)&fullent,"/");
				      strcat((char*)&fullent,(char*)&entry->d_name);
				      if (dircache_isdir((char*)&fullent))
					  dirlow_removedir((char*)&fullent);
				      else
					  remove((char*)&fullent);
			      }
			    ;
		    }
		  ;
		  closedir(dir);
	  }
	;
	return (rmdir(d)==0);
}
;
			 
int dirlow_mkdirin(char *p,char *d)
{
	char *buf;
	int success;
	
	buf=(char*)malloc(256);
	strcpy(buf,p);
	if (p[strlen(p)-1]!="/"[0])
	    strcat(buf,"/");
	strcat(buf,d);
	success=(mkdir(buf,0777)==0);
	free(buf);
	return success;
}
;
