
#include <gtk/gtk.h>
#include <unistd.h>
#include <stdio.h>
#include <sys/types.h>
#include <dirent.h>

#include "main.h"
#include "dndsetup.h"
#include "selectlist.h"
#include "filelist.h"

filelist_info *filelist_create(char *path,
			       selectlist_dropcallback drophandler,
			       int send,int popup,
			       GtkTreeItem *treeentry,
			       GtkSignalFunc item_remove,
			       GtkSignalFunc mkdir,
			       GtkSignalFunc doubleclick
			       )
{
	filelist_info *fi;
	GtkWidget *column;
	char header[1024];
	
	DIR *dir;
	struct dirent *entry;
	
	char *file[3];
	char fsbuf[25];
	
	fi=(filelist_info*)malloc(sizeof(filelist_info));
	strcpy((char*)&fi->path,path);
	fi->treeentry=treeentry;
	
	fi->widget=gtk_scrolled_window_new(NULL,NULL);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(fi->widget),
				       GTK_POLICY_AUTOMATIC,
				       GTK_POLICY_AUTOMATIC);
	strcpy((char*)&header,"file:");
	strcat((char*)&header,path);
	if (header[strlen((char*)&header)-1]!="/"[0]) 
	    strcat((char*)&header,"/");
	fi->selectlistinfo=selectlist_info_create((char*)&header,
						  0,
						  drophandler,
						  send,
						  popup,
						  item_remove,
						  mkdir,
						  doubleclick);
	column=selectlist_create(fi->selectlistinfo,
				 3); // create 3 columns
	gtk_clist_set_selection_mode(GTK_CLIST(column),GTK_SELECTION_EXTENDED);
	gtk_clist_set_column_justification(GTK_CLIST(column),
					   0,
					   GTK_JUSTIFY_LEFT);
	gtk_clist_set_column_width(GTK_CLIST(column),0,196);
	gtk_clist_set_column_justification(GTK_CLIST(column),
					   1,
					   GTK_JUSTIFY_LEFT);
	gtk_clist_set_column_width(GTK_CLIST(column),1,40);
	gtk_clist_set_column_justification(GTK_CLIST(column),
					   2,
					   GTK_JUSTIFY_RIGHT);
	gtk_clist_set_column_width(GTK_CLIST(column),2,96);
	
	file[2]=(char*)&fsbuf;
	
	dir=opendir(path);
	if (dir!=NULL)
	  {		  
		  while ((entry=readdir(dir))!=NULL)
		    {
			    file[0]=(char*)&entry->d_name;
			    if (strcmp(file[0],"..")&&strcmp(file[0],"."))
			      {
				      file[1]=(dircache_isdirin(path,file[0])?"<DIR>":"");
				      sprintf(file[2],"%i",dircache_filesizein(path,file[0]));
				      gtk_clist_append(GTK_CLIST(column),file);
			      }
			    ;
		    }
		  ;
		  closedir(dir);
	  }
	;
		
	gtk_widget_show(column);
	gtk_scrolled_window_add_with_viewport (GTK_SCROLLED_WINDOW(fi->widget),column);

	return fi;
}
;
		  

void filelist_destroy(filelist_info *fi)
{
	gtk_widget_destroy(fi->widget);
	free(fi->selectlistinfo);
	free(fi);
}
;
