/* This is the "stream:/xxx" to tracks_trackinfo convert function
 * any valid stream has to be registered to that library with its stream:/xxx
 * name,so that it can be accessed from the track-editor and converted into
 * a normal Track-pipe, xxx is the corresponds to the stream name as stored
 * in tracks_trackinfo::name,so this identifier has to be unique */

#ifndef STREAMS_H
#define STREAMS_H

#include "tracks.h"

#define STREAMS_MAX 1024

extern tracks_trackinfo *streams_stream[STREAMS_MAX];
extern int streams_count;

/* register a stream, return -1 if no more space and running number of the
 * stream,if successful. */
int streams_register(tracks_trackinfo *track);
/* unregister a stream by its running number */
void streams_unregisterbynumber(int n);
/* get the running number of a stream by specifying its name 
 * returns -1 if not found */
int streams_getstreamnumberbyname(char *name);
/* get a stream by its name,returns NULL if not found */
tracks_trackinfo *streams_getstreambyname(char *name);
/* unregister a stream by its name */
void streams_unregisterbyname(char *name);

#endif // STREAMS_H
